<p>Razmotrite sklop sličan prethodno prikazanom. Radi se o sklopu imena <em>ispitivalo2</em>
   čije je sučelje prikazano na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(ispitivalo2.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Sučelje sklopa <em>ispitivalo2</em>.</figcaption>
</figure>

<p>Sklop na ulazu dobiva 3-bitni binarni broj. Sklop ima dva jednobitna izlaza: <code>m</code> i <code>x</code>.
   Izlaz <code>m</code> mora biti <code>'1'</code> samo ako je vrijednost broja dovedenog na ulaz jednaka 7. 
   Izlaz <code>x</code> mora biti <code>'1'</code> samo ako je vrijednost broja dovedenog na ulaz manja od 5.</p> 

<form id="mojFormular" onsubmit="return false;">
<div class="mlQuestionText">
  <div>
    Vaš zadatak je sljedeći. Napišite cjelokupnu VHDL specifikaciju sklopa <code>ispitivalo2</code>. Ulaze sklopa
    definirajte uporabom podatkovnog tipa koji omogućava definiranje grupe bitova. Ne smijete koristiti interne
    signale a u tijelu arhitekture smijete pristupati samo pojedinačnim bitovima grupe bitova s ulaza (ne grupama 
    ili podgrupama). Arhitekturu nazovite <code>dataflow</code>.
  </div>
  <div>Naredba:<br>
       <textarea rows="10" cols="60" id="unos" name="unos"></textarea><br>
       <button onclick="provjeri(document.getElementById('unos').value, true, 'rez'); return false;">Provjeri</button><br>
       <div id="rez"></div>
  </div>
</div>
</form>

<script src="@#file#(vhdlparser.js)" type="text/javascript" charset="utf-8"></script>
<script src="@#file#(vhdlcheckers.js)" type="text/javascript" charset="utf-8"></script>
<script src="@#file#(vhdlboolean.js)" type="text/javascript" charset="utf-8"></script>
<script>
  var konfiguracija = @#raw-text#(jsinitdata);
  document.getElementById('unos').value = konfiguracija.enteredText;

  function questionCollectUserData() {
    let v = document.getElementById('unos').value;
    return {
      enteredText: v,
      textOK: provjeri(v, false, null)
    };
  }

  function provjeri(text, verbose, izlaz) {
      try {
        let tools = new VHDLCheckerTools();
        let builder = tools.buildVHDLChecker(text, function(parser) {return parser.parseDesignUnit()});
        if(!builder.result.hasAnyErrorsOrInfos()) {

          let libNames = builder.node.libNames;
          let useNames = builder.node.useNames;
          tools.checkLibUses(builder.result, libNames, useNames, ["ieee"], [["ieee", "std_logic_1164", "all"]]);

          while(true) { // provide scoping for check-skipping...
            var targetEntity = new VHDLEntity("ispitivalo2", [
              new VHDLPort("n", VHDLPort.MODE_IN, "std_logic_vector", new VHDLRange(2,0,VHDLRange.DIRECTION_DOWNTO)),
              new VHDLPort("m", VHDLPort.MODE_OUT, "std_logic", null),
              new VHDLPort("x", VHDLPort.MODE_OUT, "std_logic", null)
            ]);
            tools.compareWithTargetEntity(builder.result, builder.node.entity, targetEntity, true);
            let arch = builder.node.architecture;
            let result = builder.result;
            if(arch.archName != "dataflow") {
              result.errorMessages.push("Naziv arhitekture treba biti 'dataflow'. Kod Vas je: '"+arch.archName+"'. Popravite to.");
            }
            if(arch.definitions!=null && arch.definitions.length>0) {
              result.errorMessages.push("Deklaracijski dio arhitekture (dio prije 'BEGIN') ne smije sadržavati definicije internih signala i drugih elemenata. Popravite to.");
              break;
            }
            if(arch.statements==null || arch.statements.statements==null || arch.statements.statements.length != 2) {
              result.errorMessages.push("U tijelu arhitekture morate napisati točno 2 naredbe: po jednu za svaki izlaz.");
            }
            if(arch.statements==null || arch.statements.statements==null) {
              break;
            }
            if(tools.checkNoDuplicateNames(builder.result, builder.node)) break;
            let usableNames = tools.extractUsableRWNames(builder.node);
            let defExpressions = {};
            tools.concCommandsIterate(builder.node, function(c) {
              if(c.nodeType != VHDLParser.TN_CONDITIONAL_SIGNAL_ASSIGNMENT) {
                result.errorMessages.push("Dozvoljena je uporaba samo jednostavnih naredbi dodjeljivanja. Pronađena je naredba koja to nije.");
                return;
              }
              if(c.target.nodeType != VHDLParser.TN_SIMPLE_NAME) {
                result.errorMessages.push("Na lijevoj strani izraza dodjeljivanja smijete koristiti samo imena jednobitnih signala; nije dopuštena uporaba raspona, agregacija i slično.");
                return;
              }
              if(c.waveforms.length > 1 || c.waveforms[0].condition != null) {
                result.errorMessages.push("Nije dozvoljena uporaba konstrukta WHEN. Pronađena je naredba koja to koristi.");
                return;
              }
              if(c.waveforms[0].waveform.delay != null) {
                result.errorMessages.push("Nije dozvoljena uporaba kašnjenja. Pronađena je naredba koja to koristi.");
                return;
              }
              if(!tools.checkNameIsValid(usableNames, c.target.name)) {
                result.errorMessages.push("'"+c.target.name+"' je nepoznato ime.");
                return;
              }
              if(!tools.checkNameIsWritable(usableNames, c.target.name)) {
                result.errorMessages.push("'"+c.target.name+"' se ne može nalaziti s lijeve strane operatora pridruživanja.");
                return;
              }
              let tnm = c.target.name.toLowerCase();
              if(defExpressions[tnm] === undefined) {
                defExpressions[tnm] = c.waveforms[0].waveform.expression;
              } else {
                result.errorMessages.push("Više puta definirate vrijednost za '"+c.target.name+"'. U ovom zadatku to nije dopušteno.");
                return;
              }
            });
            provjeriIzraz(result, "m", defExpressions, ["n(2)","n(1)","n(0)"], ["and","or","nand","nor","xor","xnor"], ["not"], [0,0,0,0, 0,0,0,1]);
            provjeriIzraz(result, "x", defExpressions, ["n(2)","n(1)","n(0)"], ["and","or","nand","nor","xor","xnor"], ["not"], [1,1,1,1, 1,0,0,0]);
            break;
          } // end-while-loop
        }
        if(verbose) {
          tools.generateHTMLResultRepresentation(builder.result, izlaz);
        }

        if(builder.result.hasAnyErrorsOrInfos()) {
          return false;
        }
        return true;
      } catch(errx) {
        if(verbose) document.getElementById(izlaz).innerHTML = "<strong>Napisani kod ne može se parsirati.</strong><br>Prijavljena greška je: "+(errx.message===undefined ? errx : errx.message);
        return false;
      }
  }

  function provjeriInterneSignale(result, definitionsArray, allowedSignals) {
    function findSigDef(name) {
      let nm = name.toLowerCase();
      for(let i = 0; i < allowedSignals.length; i++) {
        if(allowedSignals[i].name.toLowerCase() === nm) return allowedSignals[i];
      }
      return null;
    }
    function compareDefs(def1, def2) {
      if(def1.kind != def2.kind) {
        result.errorMessages.push("'"+def2.name+"' treba biti deklariran kao '"+def2.kind+"' a deklariran je kao '"+def1.kind+"'");
        return false;
      }
      if(def1.typeSpec.nodeType != def2.typeSpec.nodeType) {
        result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka.");
        return false;
      }
      if(def1.typeSpec.nodeType === VHDLParser.TN_SIMPLE_NAME) {
        if(def1.typeSpec.name.toLowerCase() != def2.typeSpec.name.toLowerCase()) {
          result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka; očekivano je '"+def2.typeSpec.name+"'.");
          return false;
        }
      } else if(def1.typeSpec.nodeType === VHDLParser.TN_RANGED_NAME) {
        if(def1.typeSpec.name.toLowerCase() != def2.typeSpec.name.toLowerCase()) {
          result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka; očekivano je '"+def2.typeSpec.name+"'.");
          return false;
        }
        if(def1.typeSpec.range.rangeStart != def2.typeSpec.range.rangeStart) {
          result.errorMessages.push("'"+def2.name+"': očekivano je da raspon krene od vrijednosti '"+def2.typeSpec.range.rangeStart+"'.");
          return false;
        }
        if(def1.typeSpec.range.rangeEnd != def2.typeSpec.range.rangeEnd) {
          result.errorMessages.push("'"+def2.name+"': očekivano je da raspon ide do vrijednosti '"+def2.typeSpec.range.rangeEnd+"'.");
          return false;
        }
        if(def1.typeSpec.range.rangeDirection != def2.typeSpec.range.rangeDirection) {
          result.errorMessages.push("'"+def2.name+"': očekivano je da raspon bude u smjeru '"+def2.typeSpec.range.rangeDirection+"'.");
          return false;
        }
      } else {
        result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka.");
        return false;
      }
      return true;
    }

    let errs = false;
    let foundSignals = new VHDLCIStringArray();
    for(let i = 0; i < definitionsArray.length; i++) {
      let def = definitionsArray[i];
      if(def.nodeType != VHDLParser.TN_SIGCONST_DECLARATION) {
        result.errorMessages.push("U deklaracijskom dijelu arhitekture pronađena nedozvoljena naredba.");
        errs = true;
        continue;
      }
      foundSignals.push(def.name);
      if(def.kind != VHDLParser.SC_SIGNAL) {
        result.errorMessages.push("U deklaracijskom dijelu arhitekture pronađena deklaracija za '"+def.kind+"'. Smijete deklarirati samo interne signale.");
        errs = true;
        continue;
      }
      if(def.initializer != null) {
        result.errorMessages.push("U deklaraciji internog signala trenutno ne smijete koristiti inicijalizaciju.");
        errs = true;
        continue;
      }
      let targetDef = findSigDef(def.name);
      if(targetDef != null) {
        if(!compareDefs(def, targetDef)) errs = true;
      }
    }
    if(errs) return false;
    let expectedSignals = new VHDLCIStringArray();
    for(let i = 0; i < allowedSignals.length; i++) { expectedSignals.push(allowedSignals[i].name); }
    let missingSignals = expectedSignals.copy().removeAll(foundSignals);
    if(missingSignals.size()>0) {
      result.errorMessages.push("U deklaracijskom dijelu arhitekture nedostaju definicije za "+missingSignals+".");
      errs = true;
    }
    let extraSignals = foundSignals.copy().removeAll(expectedSignals);
    if(extraSignals.size()>0) {
      result.errorMessages.push("U deklaracijskom dijelu arhitekture pronađene su nepotrebne definicije za "+extraSignals+".");
      errs = true;
    }
    return !errs;
  }

  function provjeriIzraz(result, targetName, defExpressions, allowedVars, allowedBinOpers, allowedUnOpers, truthTable) {
    let expr = defExpressions[targetName];
    if(expr===undefined) {
      result.errorMessages.push("Niste specificirali izraz za signal " + targetName);
      return;
    }
    let varNames = VHDLCIStringArray.fromArray(allowedVars);
    let exInfo = new ExpressionInfoExtractor();
    expr.accept(exInfo);
    let extraNames = exInfo.usedNames.copy().removeAll(varNames);
    let varProblems = false;
    if(extraNames.size()>0) {
      result.errorMessages.push("Izraz za signal " + targetName + " sadrži nepotrebne signale: "+extraNames+". Uklonite ih.");
      varProblems = true;
    }
    let missingNames = varNames.copy().removeAll(exInfo.usedNames);
    if(missingNames.size()>0) {
      result.errorMessages.push("Izraz za signal " + targetName + " ne sadrži očekivane signale: "+missingNames+". Ispravite to.");
      varProblems = true;
    }
    if(varProblems) {
      return;
    }
    if(!provjeriTablicuIstinitosti(result, targetName, varNames, expr, truthTable)) {
      return;
    }
    let extraBinOpers = VHDLCIStringArray.fromArray(exInfo.usedBinaryOperators).removeAll(allowedBinOpers);
    if(extraBinOpers.size()>0) {
      result.errorMessages.push("Izraz za signal " + targetName + " je u logičkom smislu ispravan (predstavlja očekivanu Booleovu funkciju) ali sadrži binarne operatore koji nisu očekivani: "+extraBinOpers+". Ispravite to.");
      return;
    }
    let extraUnOpers = VHDLCIStringArray.fromArray(exInfo.usedUnaryOperators).removeAll(allowedUnOpers);
    if(extraUnOpers.size()>0) {
      result.errorMessages.push("Izraz za signal " + targetName + " je u logičkom smislu ispravan (predstavlja očekivanu Booleovu funkciju) ali sadrži unarne operatore koji nisu očekivani: "+extraUnOpers+". Ispravite to.");
      return;
    }
  }

  function provjeriTablicuIstinitosti(result, targetName, varNames, expr, truthTable) {
    let builder = new BooleanFunctionBuilder(varNames, false);
    expr.accept(builder);
    if(builder.exprStack.length != 1) {
      result.errorMessages.push("Došlo je do pogreške pri izgradnji Booleovog izraza koji odgovara signalu " + targetName + ".");
      return false;
    }
    let boolFunc = builder.exprStack[0];
    
    let values = []; for(let i = 0; i < varNames.size(); i++) values.push(0);
    let bv = new BFCalcExpressionVisitor(values);
    let rowIndex = 0;
    let errors = false;
    let exampleValues = null, exampleExp = null, exampleGot = null;
    (function rec(pos) {
      if(pos < values.length) {
        values[pos] = 0;
        rec(pos+1);
        values[pos] = 1;
        rec(pos+1);
      } else {
        boolFunc.accept(bv);
        let gotValue = bv.stack.pop();
        if(truthTable[rowIndex] != gotValue) {
          errors = true;
          if(exampleValues===null) {
            exampleValues = values.concat([]);
            exampleExp = truthTable[rowIndex];
            exampleGot = gotValue;
          }
        }
        rowIndex++;
      }
    })(0);
    if(errors) {
      result.errorMessages.push("Izraz koji ste specificirali za signal " + targetName + " ne odgovara očekivanoj Booleovoj funkciji. Primjerice za "+varNames+"=["+exampleValues+"] očekivana je vrijednost "+exampleExp+" a specificirana funkcija generira vrijednost "+exampleGot+".");
    }
    return !errors;
  }

</script>

